package fr.im2ag.m2cci.panier;

import java.util.Iterator;

/**
 * Modélise un Panier électronique pour une application de e-commerce.
 *
 *
 * @author Philippe GENOUD - Université Grenoble Alpes (UGA) - Laboratoire
 * Informatique de Grenoble (LIG) - équipe STeamer
 */
public class Panier implements Iterable<ArticlePanier> {

    /**
     * Crée un panier vide
     */
    public Panier() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    /**
     * ajoute un produit au panier. Si le panier ne contient par d'article pour
     * ce produit, un nouvel article est créé. Sinon, la quantité associée à
     * l'article correspondant est augmentée de la quantité donnée.
     *
     * @param p le produit à ajouter au panier.
     * @param quantite la quantité pour ce produit.
     *
     * @throws IllegalArgumentException si la quantité est < 1
     */
    public void ajouter(Produit p, int quantite) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    /**
     * Augmente la quantité associée à un article présent dans le panier.
     *
     * @param codeProduit le code du produit pour lequel la quantité doit être
     * modifiée.
     *
     * @param deltaQuantite la quantité à ajouter au produit.
     *
     * @throws IllegalArgumentException si deltaQuantite <= 0
     *
     * @throws ProduitNonPresentException si codeProduit ne correspond à aucun
     * des articles du panier.
     */
    public void augmenterQuantite(int codeProduit, int deltaQuantite) throws ProduitNonPresentException {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    /**
     * Diminue la quantité associée à un article présent dans le panier.
     *
     * @param codeProduit le code du produit pour lequel la quantité doit être
     * modifiée.
     *
     * @param deltaQuantite la quantité à retirer à l'article associé à ce
     * produit. si deltaQuantite >= quantité du produit, l'article est supprimé
     * du panier
     *
     * @throws IllegalArgumentException si deltaQuantite <= 0
     *
     * @throws ProduitNonPresentException si codeProduit ne correspond à aucun
     * des articles du panier.
     */
    public void diminuerQuantite(int codeProduit, int deltaQuantite) throws ProduitNonPresentException {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    /**
     * renvoie le prix total Hors Taxes du contenu panier
     *
     * @return le prix total HT
     */
    public double getPrixTotalHT() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    /**
     * renvoie le prix total TTC du contenu panier
     *
     * @return le prix total TTC
     */
    public double getPrixTotalTTC() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    /**
     * vide completement le panier
     */
    public void vider() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    /**
     * supprime un article du panier
     *
     * @param codeProduit l'identifiant du produit pour lequel l'article doit
     * être supprimé. Sans effet si il n'y a pas dans le panier d'article
     * correspondant à codeProduit
     */
    public void supprimer(int codeProduit) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    /**
     * renvoie un iterateur permettant de parcourir l'ensemble des articles
     * présents dans le panier
     *
     * @return iterateur
     */
    @Override
    public Iterator<ArticlePanier> iterator() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    /**
     *
     * @return le nombre d'articles présents dans le panier
     */
    public int getNbArticles() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    /**
     * Recherche un article dans le panier
     *
     * @param codeProduit le code du produit
     * @return l'article correspondant au code produit si il existe, null sinon
     */
    public ArticlePanier getArticle(int codeProduit) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
}
